# UniTAP.dev.ports.modules.link.dp.link_tx_types

class DPLinkPattern(enum.IntEnum):

Class `DPLinkPattern` contains all possible variants of DP link patterns. Names TrainingPattern1, TrainingPattern2, TrainingPattern3, TrainingPattern4 will be deleted in RC 3.7

ActiveVideo = <DPLinkPattern.ActiveVideo: 0>
IdlePattern = <DPLinkPattern.IdlePattern: 1>
TrainingPattern1 = <DPLinkPattern.TrainingPattern1: 2>
TrainingPattern2 = <DPLinkPattern.TrainingPattern2: 3>
TrainingPattern3 = <DPLinkPattern.TrainingPattern3: 4>
TrainingPattern4 = <DPLinkPattern.TrainingPattern4: 5>
PRBS7 = <DPLinkPattern.PRBS7: 6>
HBR2 = <DPLinkPattern.HBR2: 7>
SER = <DPLinkPattern.SER: 8>
ForceVideo = <DPLinkPattern.ForceVideo: 10>
ForceIdle = <DPLinkPattern.ForceIdle: 11>
PRBS9 = <DPLinkPattern.PRBS9: 12>
PRBS11 = <DPLinkPattern.PRBS11: 13>
PRBS15 = <DPLinkPattern.PRBS15: 14>
PRBS23 = <DPLinkPattern.PRBS23: 15>
PRBS31 = <DPLinkPattern.PRBS31: 16>
LinkSquarePattern = <DPLinkPattern.LinkSquarePattern: 17>
Undefined = <DPLinkPattern.Undefined: 18>
TPS1 = <DPLinkPattern.TrainingPattern1: 2>
TSP2 = <DPLinkPattern.TrainingPattern2: 3>
TSP3 = <DPLinkPattern.TrainingPattern3: 4>
TSP4 = <DPLinkPattern.TrainingPattern4: 5>

##### Inherited Members

enum.Enum
  name
  value
builtins.int
  conjugate
  bit_length
  bit_count
  to_bytes
  from_bytes
  as_integer_ratio
  real
  imag
  numerator
  denominator

class DP128b132bLinkPattern(enum.IntEnum):

Class `DP128b132bLinkPattern` contains all possible output patterns in DP2.0 force link mode.

ActiveVideo = <DP128b132bLinkPattern.ActiveVideo: 0>
IdlePattern = <DP128b132bLinkPattern.IdlePattern: 1>
TPS1 = <DP128b132bLinkPattern.TPS1: 2>
TPS2 = <DP128b132bLinkPattern.TPS2: 3>
PRBS9 = <DP128b132bLinkPattern.PRBS9: 4>
PRBS11 = <DP128b132bLinkPattern.PRBS11: 5>
PRBS15 = <DP128b132bLinkPattern.PRBS15: 6>
PRBS23 = <DP128b132bLinkPattern.PRBS23: 7>
PRBS31 = <DP128b132bLinkPattern.PRBS31: 8>
Custom80bit = <DP128b132bLinkPattern.Custom80bit: 9>
LinkSquarePattern = <DP128b132bLinkPattern.LinkSquarePattern: 10>
PRBS7 = <DP128b132bLinkPattern.PRBS7: 11>

##### Inherited Members

enum.Enum
  name
  value
builtins.int
  conjugate
  bit_length
  bit_count
  to_bytes
  from_bytes
  as_integer_ratio
  real
  imag
  numerator
  denominator

class DPOutLinkMode(enum.IntEnum):

Class `DPOutLinkMode` contains all possible out link modes.

Normal = <DPOutLinkMode.Normal: 0>
Force8b10b = <DPOutLinkMode.Force8b10b: 1>
Force128b132b = <DPOutLinkMode.Force128b132b: 2>

##### Inherited Members

enum.Enum
  name
  value
builtins.int
  conjugate
  bit_length
  bit_count
  to_bytes
  from_bytes
  as_integer_ratio
  real
  imag
  numerator
  denominator

class SSCConfig:

Class `SSCConfig` contains information about SSC configuration parameters.

- Set and get amplitude `amplitude`.
- Set and get frequency `frequency`.
- Enable flag.

enabled
amplitude
frequency
class LinkConfig:

Main class contains variants of link configuration:

- DP 1.4 config `DP8b10b`.
- DP 2.1 config `DP128b132b`.

class LinkConfig.DP8b10b:

Class `DP8b10b` contains information of possible DP 1.4 configuration. Contains following field:

- lane count
- link bit rate
- MST
- MST stream count
- set enhanced framing mode
- Auto seed
- SSC
- FEC
- Force EDID timings after link training
- Adaptive-Sync auto enable
- Split SDP (if supported)

lane_count
bit_rate
mst
mst_stream_count
enhanced_framing_mode
auto_seed
ssc
fec
force_edid_timings_after_lt
adaptive_sync_auto_enable
split_sdp
class LinkConfig.DP128b132b:

Class `DP128b132b` contains information of possible DP 2.1 configuration. Contains following field:

- lane count
- link bit rate
- Force DP 128/132
- Maximum link bandwidth supported
- Set enhanced framing mode
- Auto seed
- SSC
- LLTPR
- Try (enable/disable) DP 128/132
- Old DP2 link training
- Force EDID timings after link training
- Adaptive-Sync auto enable
- Split SDP (if supported)
- Force eDP rates

lane_count
bit_rate
force_dp_128_132
enhanced_framing_mode
max_link_bandwidth_supported
old_dp2_lt
lttpr
try_dp_128_132
auto_seed
ssc
force_edid_timings_after_lt
adaptive_sync_auto_enable
mst
mst_stream_count
crc_16
class LinkConfig.Force8b10b:
lane_count
bit_rate
pattern
class LinkConfig.Force128b132b:
lane_count
bit_rate
pattern
class LinkConfig.eDP:
lane_count
force_edp
eDp_cur_rate
eDp_supported_rates
eDp_aux_preamble
class LinkStatus:

Main class describes current link status. Contains following field:

- Lane count
- BIt rate
- State of enhanced framing
- State of MST mode
- State of DSC mode
- LTTPR
- Link encoding `DpLinkEncoding`
- State of scrambling
- State of SSC
- State of FEC
- State of eDP

lane_count
bit_rate
enhanced_framing
mst_enabled
dsc_enabled
lttpr
link_encoding
scrambling_enabled
ssc_enabled
fec_enabled
force_edp_enabled